use strict;
use warnings;
use utf8;
use Encode qw(from_to encode decode is_utf8 encode_utf8);
use Encode::Guess qw/shift-jis euc-jp 7bit-jis/;
# =========================================================================
    # 設定ファイル名===================================
my    $f_ini_s    = encode("shift-jis","_03_make_txt_place2line_ture_u_2kml034.ini");
    # 設定ファイルに書かれた、定数の読み込み===================================
my    ($out_ver,$flug_place,$flug_line,$flug_ture,$heading_r);                  # 基本定数
      # ture 定数の読み込み===================================
      # $altitude           = '#カメラから地表の距離(m)';
      # $tilt               = '#カメラの仰・伏角    :0は下:90は水平:90より大は上:最大は+180';
my    ($range,$altitude,$tilt,$back2_2,$gx_altitudeMode,$gx_altitudeMode_no,);
      # line 定数の読み込み===================================
my    ($line_cut);
      # 設定ファイルの読み込み===================================
      if(open(INI,"< $f_ini_s") ) {print encode("shift-jis","設定ファイルを読み込みます！！\n");}
      else                        {print encode("shift-jis","設定ファイルが有りません。終了します！！");<stdin>;exit;}
      while(<INI>) {
        chomp;
        # 基本定数の読み込み===================================
        if(/^out_ver/)            {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$out_ver            = $a[1];print "[version             = [$out_ver]\n";          ;}
        if(/^flug_place/)         {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$flug_place         = $a[1];print "[flug_place          = [$flug_place]\n";       ;}
        if(/^flug_line/)          {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$flug_line          = $a[1];print "[flug_line           = [$flug_line]\n";        ;}
        if(/^flug_ture/)          {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$flug_ture          = $a[1];print "[flug_ture           = [$flug_ture]\n";        ;}
        if(/^heading_L_R/)        {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$heading_r          = $a[1];print "[heading_r           = [$heading_r]\n";        ;}
        # ture 定数の読み込み===================================
        if(/^range/)              {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$range              = $a[1];print "[range               = [$range]\n";            ;}
        if(/^altitude/)           {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$altitude           = $a[1];print "[altitude            = [$altitude]\n";         ;}
        if(/^tilt/)               {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$tilt               = $a[1];print "[tilt                = [$tilt]\n";             ;}
        if(/^back2_2/)            {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$back2_2            = $a[1];print "[back2_2             = [$back2_2]\n";          ;}
        if(/^gx_altitudeMode_no/) {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$gx_altitudeMode_no = $a[1];print "[gx_altitudeMode_no  = [$gx_altitudeMode_no]\n";}
        # line 定数の読み込み===================================
        if(/^line_cut/)           {s/#.+$//;s/;//;s/ +//g;my @a = split("=",$_);$line_cut           = $a[1];print "[line_cut            = [$line_cut]\n";         ;}
      }
my    @levelmode = ('relativeToGround','clampToGround','absolute','relativeToSeaFloor','clampToSeaFloor');
      $gx_altitudeMode = $levelmode[$gx_altitudeMode_no];
      close(INI);
      if   ($heading_r eq "r") {$out_ver          .= "_r";print encode("shift-jis","右面に向きます\n");}
      elsif($heading_r eq "l") {$out_ver          .= "_l";print encode("shift-jis","左面に向きます\n");}
      else                     {                          print encode("shift-jis","正面に向きます\n");}
    # 設定ファイルの読み込み終了  =================================
    # データの読み込み===================================
      # 複数の[_place.txt] ファイルを一括で読み込み 処理する=======
my  @f_place;
    opendir(DRC,".");@f_place  = grep(/_u_place\.txt/i,readdir(DRC));closedir(DRC);
    if((@f_place) == 0)  {
      print encode("shift-jis","[_place\.txt]にマッチするファイルが見当たりません！]\n終了します。");<stdin>;exit;
    }
    # 複数の[_place.txt] ファイルを一つずつ 処理する=======
    foreach  my $f_in_s (@f_place) {
      # 出力ファイルの作成 =================================
my    $out_name_s = $f_in_s;
      $out_name_s =~ s/_place\.txt/_place_$out_ver\.kml/;
      open(OU,"> $out_name_s");
      # _place.txt の読み込み =================================
my    (@place,@line,@ture,@f_line);
      print "[place read]:[$f_in_s]";<stdin>;
      open(IN,"< $f_in_s");@place  = <IN>;close(IN);
      #  [_line.txt] ファイルが有れば読込む =================================
my    $f_in_s_line = $f_in_s;
      $f_in_s_line =~ s/_u_place\.txt/_u_line\.txt/;
      opendir(DRC,".");@f_line  = grep(/$f_in_s_line/i,readdir(DRC));closedir(DRC);
      if((@f_line) > 0) {
        open(IN,"< $f_line[0]");@line  = <IN>;close(IN);
        print "[line read]:[$f_line[0]]";<stdin>;
      }
      else {
        @line = @place;
        print encode("shift-jis","[_line\.txt]ファイルが見当たりません！][place.txt]で代用します。");<stdin>;
      }
      @ture = @place;
    #==================================================
    # make place & ture & line                        =
    #==================================================
my   ($titole_s,$titole_u);
      $titole_s   = $f_in_s;
      $titole_u   = decode("shift-jis",$titole_s);
      $titole_u   =~ s/\.txt/_ツアー/;
      &heder($titole_u);
    # ture ===============================================
      #  ture 定数 の設定  =========================================================
      #  高度と伏角によって、placeの[long]:[lat] から、どれだけカメラ視点の距離を離すかの計算
my    $pi         = atan2(1,1) * 4;
my    $sin1       = sin(((90 - $tilt) / 180) * $pi);
my    $cos1       = cos(((90 - $tilt) / 180) * $pi);
my    $tan1       = $sin1  / $cos1;
my    $atan1      =     1  / $tan1;
my    $back2m     = $altitude * $atan1 * $back2_2;# [$back2_2]は設定ファイルに書かれた、割引数
my    $back2      =  ($back2m / 11 ) * 0.0001 ;  # 0.0001度は ＝約 11 m 
      print encode("shift-jis","高度    = $altitude [ｍ]:伏角 = $tilt [°]\n");
      print encode("shift-jis","後退度  = $back2 [°]: 後退距離 = $back2m [ｍ]");<stdin>;
    # make_ture  =======================================
      #出発点の方向を進行方向に合わせる計算
my    (@ture_old);
my    @ture_old0    = split(/,/,$place[0]);
my    @ture_old1    = split(/,/,$place[1]);
      $ture_old[0]  = $ture_old[1] = "";
      $ture_old[2]  = $ture_old0[2] + ($ture_old0[2] - $ture_old1[2]);
      $ture_old[3]  = $ture_old0[3] + ($ture_old0[3] - $ture_old1[3]);
      print "@ture_old";<stdin>;
#      #終点に到着した時に振返る計算
#      push(@ture,$place[$#place -1 ]);
      # ture make begin =====================================
      if($flug_ture == 1) {
        &ture_heder($titole_u);
my      ($point,$description,$long,$lat,$hight,$heading);
my      $no         = 0;                        # print "ture_body[@ture]";<stdin>;
#       &ture_begin($long,$lat,$altitude,$heading,$tilt,$range,$gx_altitudeMode,$no);
#       open(HOI,"> _houi.txt");                                        # 角度  方位   経度 緯度
        foreach  my $ture(@ture) {
          $no++;
          chomp($ture);
my        @ture2    =  ($point,$description,$long,$lat,$hight) = split(",",$ture);
          # $heading            = '
          # カメラの方位角      :0は真北:0～360度';
          # place の角度とカメラの方位は違う（面倒だぁ～）
          # place の角度計算
my        $x        = $long  - $ture_old[2];
my        $y        = $lat   - $ture_old[3];
my        $atan     = atan2($y,$x) * 180 / $pi;                                 # print "no1=[$no]:atan =[$atan]:";<stdin>;
          if    ($heading_r eq "r")                 {$atan  -= 90;}
          elsif ($heading_r eq "l")                 {$atan  += 90;}             # print "no2=[$no]:atan =[$atan]:\n";
          # 進行方向、後ろ側から見るように、place の long lat を加減算する
my        $atan2    = $atan / 180 * $pi;
my        $cos2     = cos($atan2)             ; 
my        $sin2     = sin($atan2)             ;                                 # print "atan2 = $atan2:cos=[$cos2]:sin=[$sin2]";<stdin>;
my        $long2    = $back2 * $cos2;
my        $lat2     = $back2 * $sin2;                                           # print HOI "long_old[$long]:lat_old[$lat]\n";
          $long    -=  $long2;$lat     -=  $lat2;                               # print HOI "long_new[$long]:lat_new[$lat]\n";
          # カメラの方位角の計算
          if    ($atan    < -180                 )  {$atan     +=  360;}        # print "no3=[$no]:atan =[$atan]:\n";
          if    ($atan    >= -180 && $atan <=  90)  {$heading  =  90 - $atan;}
          elsif ($atan    >    90 && $atan <= 180)  {$heading  = 450 - $atan;}  # print "no4=[$no]:atan =[$atan]:heading[$heading]";<stdin>;
          #------------------------------------------------------------------------
          # print HOI "@ture2\n";
          # print HOI "@ture_old\n";
          # print HOI "x = $x : y = $y : atan = $atan : heading:$heading\n";      # print     "x = $x : y = $y : atan = $atan : heading:$heading";<stdin>;
          @ture_old    = @ture2;
          &ture_body($long,$lat,$altitude,$heading,$tilt,$range,$gx_altitudeMode,$no);
        }
        $no++;
        &ture_futter($long,$lat,$altitude,$heading,$tilt,$range,$gx_altitudeMode,$no);
        print "[ture_END]";<stdin>;
      }
    # line ===============================================
    # line の作成                                   =
      if($flug_line == 1) {
        my $file_count++;
        &line_heder($file_count);
        foreach  my $line (@line) {                                  # print "line[$line]";<stdin>;
          chomp($line);                                              # print "[$line]";<stdin>;
          my @a = split(",",$line);                                  # print    "$line2[2],$line2[3],$line2[4]";<stdin>;
          print    "$a[2],$a[3],$a[4]\n";                            #<stdin>;
          print OU "$a[2],$a[3],$a[4]\n";                            #    print OU "$line2[2],$line2[3],$line2[4]\n";
        }
        &line_futter;
      }
    #================================================
    # place                                         =
      if($flug_place  == 1) {
        my ($underwater_no_place,$no_place);
        my ($place,$point,$description,$long,$lat,$hight);
        my $place_last = pop(@place);
        $no_place = 0;
        foreach  my $place (@place) {
          $no_place++;
          $underwater_no_place = "underwater" . $no_place;
          chomp($place);                                               # print "place[#place]";<stdin>;
          ($point,$description,$long,$lat,$hight) = split(",",$place);
          &place_body($underwater_no_place,$point,$description,$long,$lat,$hight);                                                  # if($point eq 1) {  print "point[$point]";<stdin>;}
        }
        ($point,$description,$long,$lat,$hight) = split(",",$place_last);
        $no_place++;
        $underwater_no_place = "underwater" . $no_place;
        &place_futter($underwater_no_place,$point,$description,$long,$lat,$hight);                                                  # if($point eq 1) {  print "point[$point]";<stdin>;}
      }
    #================================================
      &futter;
      close(OU);
    }
print "[END]";<stdin>;
# sub =========================================================================================
# sub ture ======================================================
sub ture_heder {
my  ($titole_u) = @_;
my  $ture_hedder = <<EOF;
<!-- ture -->
    <gx:Tour>
      <name>$titole_u スタート</name>
      <gx:Playlist>
EOF
print OU encode("utf-8",$ture_hedder);

}
sub ture_begin {
my ($long,$lat,$altitude,$heading,$tilt,$range,$gx_altitudeMode,$no) = @_;
print OU <<EOF;
        <gx:FlyTo><gx:duration>8</gx:duration><gx:flyToMode>smooth</gx:flyToMode><LookAt><longitude>$long</longitude><latitude>$lat</latitude><altitude>$altitude</altitude><heading>$heading</heading><tilt>$tilt</tilt><range>$range</range><gx:altitudeMode>$gx_altitudeMode</gx:altitudeMode></LookAt></gx:FlyTo>
        <gx:AnimatedUpdate><gx:duration>0.0</gx:duration><Update><targetHref></targetHref><Change><Placemark targetId="underwater$no"><gx:balloonVisibility>1</gx:balloonVisibility></Placemark></Change></Update></gx:AnimatedUpdate>
        <gx:Wait><gx:duration>3.0</gx:duration></gx:Wait>
        <gx:AnimatedUpdate><gx:duration>0.0</gx:duration><Update><targetHref></targetHref><Change><Placemark targetId="underwater$no"><gx:balloonVisibility>0</gx:balloonVisibility></Placemark></Change></Update></gx:AnimatedUpdate>
EOF
}
sub ture_body {
my ($long,$lat,$altitude,$heading,$tilt,$range,$gx_altitudeMode,$no) = @_;
print OU <<EOF;
        <gx:FlyTo><gx:duration>8</gx:duration><gx:flyToMode>smooth</gx:flyToMode><LookAt><longitude>$long</longitude><latitude>$lat</latitude><altitude>$altitude</altitude><heading>$heading</heading><tilt>$tilt</tilt><range>$range</range><gx:altitudeMode>$gx_altitudeMode</gx:altitudeMode></LookAt></gx:FlyTo>
        <gx:AnimatedUpdate><gx:duration>0.0</gx:duration><Update><targetHref></targetHref><Change><Placemark targetId="underwater$no"><gx:balloonVisibility>1</gx:balloonVisibility></Placemark></Change></Update></gx:AnimatedUpdate>
        <gx:Wait><gx:duration>3.0</gx:duration></gx:Wait>
        <gx:AnimatedUpdate><gx:duration>0.0</gx:duration><Update><targetHref></targetHref><Change><Placemark targetId="underwater$no"><gx:balloonVisibility>0</gx:balloonVisibility></Placemark></Change></Update></gx:AnimatedUpdate>

EOF
}
sub ture_futter {
my ($long,$lat,$altitude,$heading,$tilt,$range,$gx_altitudeMode,$no) = @_;
print OU <<EOF;
        <gx:FlyTo><gx:duration>3</gx:duration><gx:flyToMode>smooth</gx:flyToMode><LookAt><longitude>$long</longitude><latitude>$lat</latitude><altitude>$altitude</altitude><heading>$heading</heading><tilt>$tilt</tilt><range>$range</range><gx:altitudeMode>$gx_altitudeMode</gx:altitudeMode></LookAt></gx:FlyTo>
        <gx:AnimatedUpdate><gx:duration>0.0</gx:duration><Update><targetHref></targetHref><Change><Placemark targetId="onland"><gx:balloonVisibility>1</gx:balloonVisibility></Placemark></Change></Update></gx:AnimatedUpdate>
        <gx:Wait><gx:duration>3.0</gx:duration></gx:Wait>
      </gx:Playlist>
    </gx:Tour>
EOF
}
# line =========================================================================================
sub line_heder {
    my ($file_count) = @_;
# <!-- line -->
print OU <<EOF;
    <Style id="linestyleExample"><LineStyle><color>7f0000ff</color><width>4</width></LineStyle></Style>
    <Placemark>
      <styleUrl>#linestyleExample</styleUrl>
      <name>軌跡$file_count</name>
      <LineString>
        <extrude>1</extrude>
        <tessellate>1</tessellate>
        <coordinates>
EOF
}
sub line_futter {
print OU <<EOF;
        </coordinates>
      </LineString>
    </Placemark>
EOF
}
# place ==========================================================================================
sub place_body {
  my ($underwater_no_place,$point,$description,$long,$lat,$hight) = @_;                                                  # if($point eq 1) {  print "point[$point]";<stdin>;}
#<!-- place -->
print OU <<EOF;
    <Placemark id="$underwater_no_place"><name>$point</name><description>$description</description><Point><gx:altitudeMode>relativeToGround</gx:altitudeMode><coordinates>$long,$lat,$hight</coordinates></Point></Placemark>
EOF
}
sub place_futter {
  my ($underwater_no_place,$point,$description,$long,$lat,$hight) = @_;                                                  # if($point eq 1) {  print "point[$point]";<stdin>;}
print OU <<EOF;
    <Placemark id="onland"><name>$point</name><description><gx:balloonVisibility>1</gx:balloonVisibility></description><Point><coordinates>$long,$lat,$hight</coordinates></Point></Placemark>
EOF
}
# header & futter ===============================================================================
sub heder {
  my ($titole_u) = @_;
print OU <<EOF;
<?xml version="1.0"  encoding="UTF-8"?>
<kml xmlns="http://www.opengis.net/kml/2.2" xmlns:gx="http://www.google.com/kml/ext/2.2">
  <Document>
    <name>$titole_u</name>
    <open>1</open>
EOF
}
sub futter {
print OU <<EOF;
  </Document>
</kml>
EOF
}
